#!/bin/sh

set -e

prgnam="$(basename $0)"
cwd="$(basename $(pwd))"

exclude='.git'
tar='tar'
bzip='bzip2 -9'

if	[ "$#" -le 0 ]
then
	printf '%s TARBALL\n' "$prgnam"
	printf 'Creates: TARBALL.tar.bz2\n'
	printf 'Excludes: %s\n' "$exclude"
	exit 1
fi

tarball="$1"
shift 1

cd ..
$tar -cf "$tarball.tar"	"$cwd/" --exclude='.git'\
	--transform="s@$cwd@$tarball@"
$bzip "$tarball.tar"
mv "$tarball.tar.bz2" "$cwd/"

