#!/bin/sh

set -e

prgnam="$(basename $0)"

if	[ "$#" -lt "1" ]
then
	printf '%s FILES...\n' "$prgnam"
	exit 1
fi

sloc_1=0
sloc_2=0

count ()
{
	if	[ ! -f "$1" ]
	then
		printf '"%s" is not a file.\n' $1
		exit 1
	fi

	sloc_1=$(expr $sloc_1 + $(grep -c ";" $1) || true)
	sloc_2=$(expr $sloc_2 + $(printf '=\nQ\n' | ed $1 2> /dev/null))
}

for file in $@
do
	if	[ -f "$file" ]
	then
		count "$file"
	else
		printf '"%s" is not a file.\n' "$file"
		exit 1
	fi
done

printf 'Instructions: %s\n' "$sloc_1"
printf 'Newlines:     %s\n' "$sloc_2"

