#!/bin/sh

set -e

prgnam="$(basename $0)"
cols=72

if	[ "$#" -lt "1" ]
then
	printf '%s FILES...\n' "$prgnam"
	exit 1
fi

check ()
{
	if	[ ! -f "$1" ]
	then
		printf '"%s" is not a file.\n' "$1"
		exit 1
	fi

	if	[ "$(wc -L $1 | sed 's/[ 	].*$//')" -gt "$cols" ]
	then
		printf 'ERROR: Overlong line in "%s".\n' "$1"
		exit 1
	fi

	if	[ "$(printf 'g/[ 	]$/p\n\Q\n'\
		| ed $1 2> /dev/null)" != "" ]
	then
		printf 'ERROR: Trailing space or tab in "%s".\n' "$1"
		exit 1
	fi
}

for file in $@
do
	if	[ -f "$file" ]
	then
		check "$file"
	else
		printf '"%s" is not a file.\n' "$file"
		exit 1
	fi
done

printf 'Maximum line length %s:           SUCCESS.\n' "$cols"
printf 'No trailing white spaces or tabs: SUCCESS.\n'

