/*
 * Copyright © 2013-2014 Alexander Söderlund, Sweden
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef HNEF_CORE_RREAD_H
#define HNEF_CORE_RREAD_H

#include "gleipnir_lines.h"	/* gleipnir_lines */

#include "funct.h"	/* HNEF_FR, HNEF_FAIL_RREADER */
#include "gamet.h"	/* hnef_game */

/*@-protoparamname@*/
/*@unused@*/
extern
enum HNEF_FR
hnef_game_parse_line_tokens (
/*@in@*/
/*@notnull@*/
	struct hnef_game * const HNEF_RSTR game,
/*@in@*/
/*@notnull@*/
	const char	* const HNEF_RSTR * const HNEF_RSTR wordv,
	const size_t	wordc,
/*@in@*/
/*@notnull@*/
	enum HNEF_RREAD	* const HNEF_RSTR fail_read
	)
/*@globals errno@*/
/*@modifies errno, * game, * fail_read@*/
;
/*@=protoparamname@*/

/*@-protoparamname@*/
/*@unused@*/
extern
enum HNEF_FR
hnef_game_read_line_single (
/*@in@*/
/*@notnull@*/
	struct hnef_game		* const HNEF_RSTR game,
/*@in@*/
/*@notnull@*/
	const struct gleip_lines	* const GLEIP_RSTR line,
/*@in@*/
/*@notnull@*/
	enum HNEF_RREAD			* const HNEF_RSTR fail_read
	)
/*@globals errno@*/
/*@modifies errno, * game, * fail_read@*/
;
/*@=protoparamname@*/

/*@-protoparamname@*/
/*@unused@*/
extern
enum HNEF_FR
hnef_game_read_file (
/*@in@*/
/*@notnull@*/
	struct hnef_game	* const HNEF_RSTR game,
/*@in@*/
/*@notnull@*/
	FILE			* const HNEF_RSTR file,
/*@in@*/
/*@notnull@*/
	struct gleip_lines	* const GLEIP_RSTR line,
/*@in@*/
/*@notnull@*/
	enum HNEF_RREAD		* const HNEF_RSTR fail_read
	)
/*@globals errno@*/
/*@modifies errno, * game, * file, * line, * fail_read@*/
;
/*@=protoparamname@*/

/*@-protoparamname@*/
/*@unused@*/
extern
enum HNEF_FR
hnef_game_read_line (
/*@in@*/
/*@notnull@*/
	struct hnef_game	* const HNEF_RSTR game,
/*@in@*/
/*@notnull@*/
	const char		* const content,
/*@in@*/
/*@notnull@*/
	struct gleip_lines	* const GLEIP_RSTR line,
/*@in@*/
/*@notnull@*/
	enum HNEF_RREAD		* const HNEF_RSTR fail_read
	)
/*@globals errno@*/
/*@modifies errno, * game, * line, * fail_read@*/
;
/*@=protoparamname@*/

/*@-protoparamname@*/
/*@unused@*/
extern
enum HNEF_FR
hnef_game_init_file (
/*@in@*/
/*@notnull@*/
	struct hnef_game	* const HNEF_RSTR game,
/*@in@*/
/*@notnull@*/
	FILE			* const HNEF_RSTR file,
/*@in@*/
/*@notnull@*/
	struct gleip_lines	* const GLEIP_RSTR line,
/*@in@*/
/*@notnull@*/
	enum HNEF_RREAD		* const HNEF_RSTR fail_read,
/*@in@*/
/*@notnull@*/
	enum HNEF_RVALID	* const HNEF_RSTR fail_valid
	)
/*@globals errno@*/
/*@modifies errno, * game, * file, * line, * fail_read, * fail_valid@*/
;
/*@=protoparamname@*/

/*@-protoparamname@*/
/*@unused@*/
extern
enum HNEF_FR
hnef_game_init_line (
/*@in@*/
/*@notnull@*/
	struct hnef_game	* const HNEF_RSTR game,
/*@in@*/
/*@notnull@*/
	const char		* const content,
/*@in@*/
/*@notnull@*/
	struct gleip_lines	* const GLEIP_RSTR line,
/*@in@*/
/*@notnull@*/
	enum HNEF_RREAD		* const HNEF_RSTR fail_read,
/*@in@*/
/*@notnull@*/
	enum HNEF_RVALID	* const HNEF_RSTR fail_valid
	)
/*@globals errno@*/
/*@modifies errno, * game, * line, * fail_read, * fail_valid@*/
;
/*@=protoparamname@*/

#endif

