/*
 * Copyright © 2013-2014 Alexander Söderlund, Sweden
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */
#include "hnefatafl.h"

#include "config.h"

const long	HNEFATAFL_UI_VERSION	= 140617L;

const char	* HNEF_UI_ENVVAR_LANG		= "HNEFATAFL_LANG",
		* HNEF_UI_ENVVAR_PATH		= "HNEFATAFL_PATH",
		* HNEF_UI_ENVVAR_RC		= "HNEFATAFL_RC",
		* HNEF_UI_ENVVAR_RULES		= "HNEFATAFL_RULES",
#ifdef	HNEFATAFL_UI_XLIB
		* HNEF_UI_ENVVAR_FONT		= "HNEFATAFL_FONT",
#endif	/* HNEFATAFL_UI_XLIB */
#ifdef	HNEFATAFL_UI_AIM
		* HNEF_UI_ENVVAR_SYS_DISPLAY	= "DISPLAY",
#endif	/* HNEFATAFL_UI_AIM */
		* HNEF_UI_ENVVAR_SYS_HOME	= "HOME",
		* HNEF_UI_ENVVAR_SYS_LC_ALL	= "LC_ALL",
		* HNEF_UI_ENVVAR_SYS_LC_CTYPE	= "LC_CTYPE",
		* HNEF_UI_ENVVAR_SYS_LANG	= "LANG";

const char *
hnef_ui_id (void)
{
#ifdef	HNEFATAFL_UI_XLIB
	return	"uicx";
#else	/* HNEFATAFL_UI_XLIB */
	return	"uic";
#endif	/* HNEFATAFL_UI_XLIB */
}

